/*
 * NIST_Demo.java
 *
 * Created on February 18, 2008, 1:20 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nist_sun_java;


public class NIST_Demo {
    
    /** Creates a new instance of NIST_Demo */
    public NIST_Demo() {
        System.loadLibrary("NIST_library_jniexport");         
    }
       

    public static native int RegisterNIST();     

    public static native int CreateNewNISTFile();    
    
    public static native int WriteNISTToFile(String filename);    
    
    public static native byte[] ReadNISTByteArray();
    
    public static native int ReadSizeOfNISTByteArray();       
    
    public static native int ReadNISTFromFile(String fileName);

    public static native int ReadNISTFromMemory(byte[] byte_array, int size_of_byte_array);
    
    public static native int CheckIfRecordTypeExists(int record_type_number);

    public static native int ReadNumberOfRecords(int record_type_number);
    
    public static native int ReadIDCofRecord(int record_type_number, int record_number);
    
    public static native String ReadRecordTxtField(int record_type_number, int idc, int record_field_number, String record_field_name);

    public static native int ReadSizeOfRecordTxtField(int record_type_number, int idc, int record_field_number, String record_field_name);    
    
    public static native String ReadRecordTxtFieldName(int record_type_number, int idc, int record_field_number);
    
    public static native int ReadSizeOfRecordTxtFieldName(int record_type_number, int idc, int record_field_number, String record_field_name);
   
    public static native String ReadRecordTxtFieldDescription(int record_type_number, int idc, int record_field_number, String record_field_name);
    
    public static native int ReadSizeOfRecordTxtFieldDescription(int record_type_number, int idc, int record_field_number, String record_field_name);
    
    public static native String ReadRecordExportedTxtFields(int record_type_number, int idc);
    
    public static native int ReadSizeOfRecordExportedTxtFields(int record_type_number, int idc);
    
    public static native byte[] ReadRecordBinaryField(int record_type_number, int idc);
    
    public static native int ReadSizeOfRecordBinaryField(int record_type_number, int idc);
    
    public static native int[] CreateHBITMAPfromRecordBinaryField(int[] dimension, int record_type_number, int idc);
    
    public static native  int InsertRecordBinaryFieldFromFile(int record_type_number, int idc, String filename);
    
    public static native  int InsertRecordBinaryFieldFromMemory(int record_type_number, int idc, byte[] input_byte_array, int size_of_input_byte_array, String CGA, int CGA_int, int HLL, int VLL);
    
    public static native  int InsertRecordTxtField(int record_type_number, int idc, int record_field_number, String record_field_name, String input_data);     
        
    public static native int DeleteRecord(int record_type_number, int idc);    
    
    public static native int SetNISTLibErrorReportMode(int nist_error_report_mode);
    
    public static native String ReadNISTLibLastErrorMessage();    
    

    
    

    
}
