/*
 * ImageFilter.java
 *
 * Created on Saturday, 2006, July 8, 00.03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package nist_sun_java;

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;
import nist_sun_java.FileFilterType;



public class ImageFilter {
    
    
    public static FileFilter NIST_Filter() {
        return new FileFilterType() {
            public boolean accept(File f) {
                if (f.isDirectory()) {
                    return false;
                }
                
                String extension = getExtension(f);
                extension = extension.toLowerCase();
                if (extension.equals("nist")) {
                    return true;
                }
                return false;
            }
        
            public String getDescription() {
                return "NIST files (*.nist)";
            }
            
            public int type() {
                return 1;
            }
        };
    }    
    
    
    
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
}
